<html>
<head>
    <title> Release Bell </title>

    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">

    <link rel="icon" type="image/png" href="/favicon.png">

    <link rel="alternate icon" type="image/png" href="/favicon.png">
    <link rel="icon" type="image/svg+xml" href="/favicon.svg">

    <link rel="stylesheet" href="/css/theme-chalk.css">
    <link rel="stylesheet" href="/css/index.css">

    <script src="/js/vue.js"></script>
    <script src="/js/element-ui.js"></script>
    <script src="/js/superagent.js"></script>

</head>
<body>

<el-container id="app">
  <el-header>
    <el-menu :default-active="activeView" class="el-menu-demo" mode="horizontal" @select="handleViewSelect">
      <el-menu-item index="welcome"><i class="el-icon-bell"></i> Release Bell</el-menu-item>
      <el-menu-item index="projects" v-show="profile">Projects</el-menu-item>
      <el-menu-item index="profile" v-show="profile">Profile</el-menu-item>
      <el-menu-item index="logout" v-show="profile" style="float: right" @click="onLogout">Logout</el-menu-item>
      <el-menu-item index="projectAdd" v-show="profile" style="float: right"><el-button type="primary">Add Project</el-button></el-menu-item>
    </el-menu>
  </el-header>
  <el-main>
    <div v-if="activeView === 'login'">
      <el-row type="flex" justify="center">
        <el-col style="max-width: 400px">
          <el-form ref="form" :model="login" label-position="top" @submit.native.prevent>
            <el-form-item label="Username"><el-input id="username" v-model="login.username" ref="loginInput" required></el-input></el-form-item>
            <el-form-item label="Password"><el-input id="password" v-model="login.password" type="password" required></el-input></el-form-item>
            <el-form-item><el-button type="primary" native-type="submit" @click="onLogin" style="width: 120px;" :disabled="loginSubmitBusy"><i class="el-icon-loading" v-show="loginSubmitBusy"></i><span v-show="!loginSubmitBusy">Login</span></el-button></el-form-item>
          </el-form>
        </el-col>
      </el-row>
    </div>
    <div v-else-if="activeView === 'projects'">
      <el-row type="flex" justify="center">
        <el-col style="max-width: 1024px">
          <center v-show="projects === null"><h1><i class="el-icon-loading"></i></h1></center>
          <center v-show="projects && projects.length === 0">No projects found.</center>
          <el-table :data="projects" v-show="projects && projects.length" stripe style="width: 100%" :default-sort="{ prop: 'name', order: 'descending' }">
            <el-table-column prop="name" label="Project Name" sortable :sort-method="sort">
              <template slot-scope="scope">
                <a :href="'https://github.com/' + scope.row.name" target="_blank" v-show="scope.row.type === 'github'">{{ scope.row.name }}</a>
                <a :href="scope.row.origin + '/' + scope.row.name" target="_blank" v-show="scope.row.type === 'gitlab'">{{ scope.row.name }}</a>
              </template>
            </el-table-column>
            <el-table-column label="Type" sortable :sort-method="sort">
              <template slot-scope="scope"><img :src="'/' + scope.row.type + '.svg'" class="type-icon"/> {{ scope.row.type }}</template>
            </el-table-column>
            <el-table-column label="" align="right">
              <template slot-scope="scope">
                <el-tag type="danger" v-show="!scope.row.enabled">Notifications are disabled</el-tag>
              </template>
            </el-table-column>
            <el-table-column label="" align="right">
              <template slot-scope="scope">
                <el-button type="text" size="small" @click="setProjectState(scope.row.id, !scope.row.enabled, scope)"><i class="el-icon-loading" v-show="scope.row.busy"></i><span v-show="!scope.row.busy">{{ scope.row.enabled ? 'Disable' : 'Enable' }}</span></el-button>
                <el-button type="text" size="small" v-show="scope.row.type !== 'github'" @click="deleteProject(scope.row.id, scope)"><i class="el-icon-loading" v-show="scope.row.busy"></i><span v-show="!scope.row.busy"> Delete</el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-col>
      </el-row>
    </div>
    <div v-else-if="activeView === 'profile'">
      <el-row type="flex" justify="center">
        <el-col style="max-width: 600px">
          <el-form ref="form" label-width="120px" @submit.native.prevent>
            <el-form-item label="Email" required><el-input v-model="profile.email" type="email"></el-input></el-form-item>
            <el-form-item label="GitHub token">
              <el-input id="githubToken" v-model="profile.githubToken" ref="githubTokenInput"></el-input>
              <a href="https://github.com/settings/tokens/new?description=ReleaseBell" target="_blank">Generate a GitHub API token</a>
            </el-form-item>
            <el-form-item><el-button id="saveProfile" type="primary" native-type="submit" @click="onProfileSubmit" style="width: 120px;" :disabled="profileSubmitBusy"><i class="el-icon-loading" v-show="profileSubmitBusy"></i><span v-show="!profileSubmitBusy">Save</span></el-button></el-form-item>
          </el-form>
        </el-col>
      </el-row>
    </div>
    <div v-else-if="activeView === 'projectAdd'">
      <el-row type="flex" justify="center">
        <el-col style="max-width: 600px">
          <el-form ref="form" label-width="120px" @submit.native.prevent>
            <el-form-item label="Type" required>
              <el-select v-model="addProject.type" placeholder="Select">
                <el-option key="github_manual" label="Github" value="github_manual"></el-option>
                <el-option key="gitlab" label="GitLab" value="gitlab"></el-option>
              </el-select>
            </el-form-item>
            <el-form-item label="Url" required><el-input v-model="addProject.url" type="text"></el-input></el-form-item>
            <el-form-item><el-button type="primary" native-type="submit" @click="onProjectAdd" style="width: 120px;" :disabled="addProject.busy"><i class="el-icon-loading" v-show="addProject.busy"></i><span v-show="!addProject.busy">Save</span></el-button></el-form-item>
            <input type="submit" @click="onProjectAdd" v-show="false"/>
          </el-form>
        </el-col>
      </el-row>
    </div>
    <div v-else-if="activeView === 'welcome'">
      <el-row type="flex" justify="center">
        <el-col style="max-width: 1024px">
          <center v-show="projects === null"><h1><i class="el-icon-loading"></i></h1></center>
          <center v-show="projects && projects.length === 0">
              <h1><i class="el-icon-bell"></i> Welcome to Release Bell</h1>
              <p>
                Set a GitHub token in your <a href="" @click.prevent="handleViewSelect('profile')">profile</a> to start receiving new release notifcations for your starred repos <br/>
                or add <a href="" @click.prevent="handleViewSelect('projectAdd')">GitLab project URLs</a> for release notifications for those projects.
              </p>
          </center>
          <el-table :data="projects" v-show="projects && projects.length" stripe style="width: 100%" :default-sort="{ prop: 'createdAt', order: 'descending' }">
            <el-table-column prop="name" label="Project Name" sortable :sort-method="sort">
              <template slot-scope="scope">
                <a :href="'https://github.com/' + scope.row.name" target="_blank" v-show="scope.row.type === 'github'">{{ scope.row.name }}</a>
                <a :href="scope.row.origin + '/' + scope.row.name" target="_blank" v-show="scope.row.type === 'gitlab'">{{ scope.row.name }}</a>
              </template>
            </el-table-column>
            <el-table-column prop="version" align="center" label="Last Version" sortable>
              <template slot-scope="scope">
                <a :href="'https://github.com/' + scope.row.name + '/releases/tag/' + scope.row.version" target="_blank" v-show="scope.row.type === 'github'">{{ scope.row.version }}</a>
                <a :href="scope.row.origin + '/' + scope.row.name + '/-/releases/' + scope.row.version" target="_blank" v-show="scope.row.type === 'gitlab'">{{ scope.row.version }}</a>
              </template>
            </el-table-column>
            <el-table-column prop="createdAt" align="right" label="Released at" sortable :formatter="prettyDate"></el-table-column>
          </el-table>
        </el-col>
      </el-row>
    </div>
    <div v-else>
      <center><h1><i class="el-icon-loading"></i></h1></center>
    </div>
  </el-main>
</el-container>

<script src="/js/index.js"></script>

</body>
</html>
